#ifndef mozilla_dom_BindingNames_h
#define mozilla_dom_BindingNames_h

#include <stddef.h>
#include <stdint.h>
#include "mozilla/Attributes.h"

namespace mozilla::dom {

enum class BindingNamesOffset : uint16_t {
  ANGLE_instanced_arrays = 0,
  APZHitResultFlags = 23,
  AbortController = 41,
  AbortSignal = 57,
  AbstractRange = 69,
  AccessibleNode = 83,
  Addon = 98,
  AddonEvent = 104,
  AddonInstall = 115,
  AddonManager = 128,
  AddonManagerPermissions = 141,
  AnalyserNode = 165,
  Animation = 178,
  AnimationEffect = 188,
  AnimationEvent = 204,
  AnimationPlaybackEvent = 219,
  AnimationTimeline = 242,
  AnonymousContent = 260,
  Attr = 277,
  Audio = 282,
  AudioBuffer = 288,
  AudioBufferSourceNode = 300,
  AudioContext = 322,
  AudioDestinationNode = 335,
  AudioListener = 356,
  AudioNode = 370,
  AudioParam = 380,
  AudioParamMap = 391,
  AudioProcessingEvent = 405,
  AudioScheduledSourceNode = 426,
  AudioTrack = 451,
  AudioTrackList = 462,
  AudioWorklet = 477,
  AudioWorkletGlobalScope = 490,
  AudioWorkletNode = 514,
  AudioWorkletProcessor = 531,
  AuthenticatorAssertionResponse = 553,
  AuthenticatorAttestationResponse = 584,
  AuthenticatorResponse = 617,
  BarProp = 639,
  BaseAudioContext = 647,
  BatteryManager = 664,
  BeforeUnloadEvent = 679,
  BiquadFilterNode = 697,
  Blob = 714,
  BlobEvent = 719,
  BroadcastChannel = 729,
  BrowsingContext = 746,
  BrowsingContextGroup = 762,
  ByteLengthQueuingStrategy = 783,
  CDATASection = 809,
  CSS = 822,
  CSS2Properties = 826,
  CSSAnimation = 841,
  CSSConditionRule = 854,
  CSSContainerRule = 871,
  CSSCounterStyleRule = 888,
  CSSFontFaceRule = 908,
  CSSFontFeatureValuesRule = 924,
  CSSGroupingRule = 949,
  CSSImportRule = 965,
  CSSKeyframeRule = 979,
  CSSKeyframesRule = 995,
  CSSLayerBlockRule = 1012,
  CSSLayerStatementRule = 1030,
  CSSMediaRule = 1052,
  CSSMozDocumentRule = 1065,
  CSSNamespaceRule = 1084,
  CSSPageRule = 1101,
  CSSPseudoElement = 1113,
  CSSRule = 1130,
  CSSRuleList = 1138,
  CSSScrollTimelineRule = 1150,
  CSSStyleDeclaration = 1172,
  CSSStyleRule = 1192,
  CSSStyleSheet = 1205,
  CSSSupportsRule = 1219,
  CSSTransition = 1235,
  Cache = 1249,
  CacheStorage = 1255,
  CallbackDebuggerNotification = 1268,
  CanonicalBrowsingContext = 1297,
  CanvasCaptureMediaStream = 1322,
  CanvasGradient = 1347,
  CanvasPattern = 1362,
  CanvasRenderingContext2D = 1376,
  CaretPosition = 1401,
  CaretStateChangedEvent = 1415,
  ChannelMergerNode = 1438,
  ChannelSplitterNode = 1456,
  ChannelWrapper = 1476,
  CharacterData = 1491,
  CheckerboardReportService = 1505,
  ChildProcessMessageManager = 1531,
  ChildSHistory = 1558,
  ChromeMessageBroadcaster = 1572,
  ChromeMessageSender = 1597,
  ChromeNodeList = 1617,
  ChromeUtils = 1632,
  ChromeWorker = 1644,
  Client = 1657,
  Clients = 1664,
  Clipboard = 1672,
  ClipboardEvent = 1682,
  ClipboardItem = 1697,
  ClonedErrorHolder = 1711,
  CloseEvent = 1729,
  CommandEvent = 1740,
  Comment = 1753,
  CompositionEvent = 1761,
  ConsoleInstance = 1778,
  ConstantSourceNode = 1794,
  ContentFrameMessageManager = 1813,
  ContentProcessMessageManager = 1840,
  ConvolverNode = 1869,
  CountQueuingStrategy = 1883,
  CreateOfferRequest = 1904,
  Credential = 1923,
  CredentialsContainer = 1934,
  Crypto = 1955,
  CryptoKey = 1962,
  CustomElementRegistry = 1972,
  CustomEvent = 1994,
  DOMException = 2006,
  DOMImplementation = 2019,
  DOMLocalization = 2037,
  DOMMatrix = 2053,
  DOMMatrixReadOnly = 2063,
  DOMParser = 2081,
  DOMPoint = 2091,
  DOMPointReadOnly = 2100,
  DOMQuad = 2117,
  DOMRect = 2125,
  DOMRectList = 2133,
  DOMRectReadOnly = 2145,
  DOMRequest = 2161,
  DOMStringList = 2172,
  DOMStringMap = 2186,
  DOMTokenList = 2199,
  DataTransfer = 2212,
  DataTransferItem = 2225,
  DataTransferItemList = 2242,
  DebuggerNotification = 2263,
  DebuggerNotificationObserver = 2284,
  DedicatedWorkerGlobalScope = 2313,
  DelayNode = 2340,
  DeprecationReportBody = 2350,
  DeviceAcceleration = 2372,
  DeviceLightEvent = 2391,
  DeviceMotionEvent = 2408,
  DeviceOrientationEvent = 2426,
  DeviceRotationRate = 2449,
  Directory = 2468,
  Document = 2478,
  DocumentFragment = 2487,
  DocumentL10n = 2504,
  DocumentTimeline = 2517,
  DocumentType = 2534,
  DominatorTree = 2547,
  DragEvent = 2561,
  DynamicsCompressorNode = 2571,
  EXT_blend_minmax = 2594,
  EXT_color_buffer_float = 2611,
  EXT_color_buffer_half_float = 2634,
  EXT_disjoint_timer_query = 2662,
  EXT_float_blend = 2687,
  EXT_frag_depth = 2703,
  EXT_sRGB = 2718,
  EXT_shader_texture_lod = 2727,
  EXT_texture_compression_bptc = 2750,
  EXT_texture_compression_rgtc = 2779,
  EXT_texture_filter_anisotropic = 2808,
  EXT_texture_norm16 = 2839,
  Element = 2858,
  ElementInternals = 2866,
  ErrorEvent = 2883,
  Event = 2894,
  EventCallbackDebuggerNotification = 2900,
  EventCounts = 2934,
  EventSource = 2946,
  EventTarget = 2958,
  Exception = 2970,
  ExtendableEvent = 2980,
  ExtendableMessageEvent = 2996,
  ExtensionAlarms = 3019,
  ExtensionBrowser = 3035,
  ExtensionEventManager = 3052,
  ExtensionMockAPI = 3074,
  ExtensionPort = 3091,
  ExtensionRuntime = 3105,
  ExtensionScripting = 3122,
  ExtensionTest = 3141,
  External = 3155,
  FeaturePolicy = 3164,
  FeaturePolicyViolationReportBody = 3178,
  FetchEvent = 3211,
  FetchObserver = 3222,
  File = 3236,
  FileList = 3241,
  FileReader = 3250,
  FileReaderSync = 3261,
  FileSystem = 3276,
  FileSystemDirectoryEntry = 3287,
  FileSystemDirectoryHandle = 3312,
  FileSystemDirectoryHandle_AsyncIterator = 3338,
  FileSystemDirectoryIterator = 3378,
  FileSystemDirectoryReader = 3406,
  FileSystemEntry = 3432,
  FileSystemFileEntry = 3448,
  FileSystemFileHandle = 3468,
  FileSystemHandle = 3489,
  FileSystemSyncAccessHandle = 3506,
  FileSystemWritableFileStream = 3533,
  Flex = 3562,
  FlexItemValues = 3567,
  FlexLineValues = 3582,
  FluentBundle = 3597,
  FluentBundleAsyncIterator = 3610,
  FluentBundleIterator = 3636,
  FluentPattern = 3657,
  FluentResource = 3671,
  FocusEvent = 3686,
  FontFace = 3697,
  FontFaceSet = 3706,
  FontFaceSetIterator = 3718,
  FontFaceSetLoadEvent = 3738,
  FormData = 3759,
  FormData_Iterator = 3768,
  FormDataEvent = 3786,
  FrameCrashedEvent = 3800,
  FrameLoader = 3818,
  GPU = 3830,
  GPUAdapter = 3834,
  GPUBindGroup = 3845,
  GPUBindGroupLayout = 3858,
  GPUBuffer = 3877,
  GPUBufferUsage = 3887,
  GPUCanvasContext = 3902,
  GPUColorWrite = 3919,
  GPUCommandBuffer = 3933,
  GPUCommandEncoder = 3950,
  GPUCompilationInfo = 3968,
  GPUCompilationMessage = 3987,
  GPUComputePassEncoder = 4009,
  GPUComputePipeline = 4031,
  GPUDevice = 4050,
  GPUDeviceLostInfo = 4060,
  GPUMapMode = 4078,
  GPUOutOfMemoryError = 4089,
  GPUPipelineLayout = 4109,
  GPUQuerySet = 4127,
  GPUQueue = 4139,
  GPURenderBundle = 4148,
  GPURenderBundleEncoder = 4164,
  GPURenderPassEncoder = 4187,
  GPURenderPipeline = 4208,
  GPUSampler = 4226,
  GPUShaderModule = 4237,
  GPUShaderStage = 4253,
  GPUSupportedFeatures = 4268,
  GPUSupportedLimits = 4289,
  GPUTexture = 4308,
  GPUTextureUsage = 4319,
  GPUTextureView = 4335,
  GPUUncapturedErrorEvent = 4350,
  GPUValidationError = 4374,
  GainNode = 4393,
  Gamepad = 4402,
  GamepadAxisMoveEvent = 4410,
  GamepadButton = 4431,
  GamepadButtonEvent = 4445,
  GamepadEvent = 4464,
  GamepadHapticActuator = 4477,
  GamepadLightIndicator = 4499,
  GamepadPose = 4521,
  GamepadServiceTest = 4533,
  GamepadTouch = 4552,
  Geolocation = 4565,
  GeolocationCoordinates = 4577,
  GeolocationPosition = 4600,
  GeolocationPositionError = 4620,
  GetUserMediaRequest = 4645,
  GleanCategory = 4665,
  GleanImpl = 4679,
  GleanLabeled = 4689,
  GleanPingsImpl = 4702,
  Grid = 4717,
  GridArea = 4722,
  GridDimension = 4731,
  GridLine = 4745,
  GridLines = 4754,
  GridTrack = 4764,
  GridTracks = 4774,
  HTMLAllCollection = 4785,
  HTMLAnchorElement = 4803,
  HTMLAreaElement = 4821,
  HTMLAudioElement = 4837,
  HTMLBRElement = 4854,
  HTMLBaseElement = 4868,
  HTMLBodyElement = 4884,
  HTMLButtonElement = 4900,
  HTMLCanvasElement = 4918,
  HTMLCollection = 4936,
  HTMLDListElement = 4951,
  HTMLDataElement = 4968,
  HTMLDataListElement = 4984,
  HTMLDetailsElement = 5004,
  HTMLDialogElement = 5023,
  HTMLDirectoryElement = 5041,
  HTMLDivElement = 5062,
  HTMLDocument = 5077,
  HTMLElement = 5090,
  HTMLEmbedElement = 5102,
  HTMLFieldSetElement = 5119,
  HTMLFontElement = 5139,
  HTMLFormControlsCollection = 5155,
  HTMLFormElement = 5182,
  HTMLFrameElement = 5198,
  HTMLFrameSetElement = 5215,
  HTMLHRElement = 5235,
  HTMLHeadElement = 5249,
  HTMLHeadingElement = 5265,
  HTMLHtmlElement = 5284,
  HTMLIFrameElement = 5300,
  HTMLImageElement = 5318,
  HTMLInputElement = 5335,
  HTMLLIElement = 5352,
  HTMLLabelElement = 5366,
  HTMLLegendElement = 5383,
  HTMLLinkElement = 5401,
  HTMLMapElement = 5417,
  HTMLMarqueeElement = 5432,
  HTMLMediaElement = 5451,
  HTMLMenuElement = 5468,
  HTMLMetaElement = 5484,
  HTMLMeterElement = 5500,
  HTMLModElement = 5517,
  HTMLOListElement = 5532,
  HTMLObjectElement = 5549,
  HTMLOptGroupElement = 5567,
  HTMLOptionElement = 5587,
  HTMLOptionsCollection = 5605,
  HTMLOutputElement = 5627,
  HTMLParagraphElement = 5645,
  HTMLParamElement = 5666,
  HTMLPictureElement = 5683,
  HTMLPreElement = 5702,
  HTMLProgressElement = 5717,
  HTMLQuoteElement = 5737,
  HTMLScriptElement = 5754,
  HTMLSelectElement = 5772,
  HTMLSlotElement = 5790,
  HTMLSourceElement = 5806,
  HTMLSpanElement = 5824,
  HTMLStyleElement = 5840,
  HTMLTableCaptionElement = 5857,
  HTMLTableCellElement = 5881,
  HTMLTableColElement = 5902,
  HTMLTableElement = 5922,
  HTMLTableRowElement = 5939,
  HTMLTableSectionElement = 5959,
  HTMLTemplateElement = 5983,
  HTMLTextAreaElement = 6003,
  HTMLTimeElement = 6023,
  HTMLTitleElement = 6039,
  HTMLTrackElement = 6056,
  HTMLUListElement = 6073,
  HTMLUnknownElement = 6090,
  HTMLVideoElement = 6109,
  HashChangeEvent = 6126,
  Headers = 6142,
  Headers_Iterator = 6150,
  HeapSnapshot = 6167,
  History = 6180,
  IDBCursor = 6188,
  IDBCursorWithValue = 6198,
  IDBDatabase = 6217,
  IDBFactory = 6229,
  IDBFileHandle = 6240,
  IDBFileRequest = 6254,
  IDBIndex = 6269,
  IDBKeyRange = 6278,
  IDBLocaleAwareKeyRange = 6290,
  IDBMutableFile = 6313,
  IDBObjectStore = 6328,
  IDBOpenDBRequest = 6343,
  IDBRequest = 6360,
  IDBTransaction = 6371,
  IDBVersionChangeEvent = 6386,
  IIRFilterNode = 6408,
  IOUtils = 6422,
  IdentityCredential = 6430,
  IdleDeadline = 6449,
  Image = 6462,
  ImageBitmap = 6468,
  ImageBitmapRenderingContext = 6480,
  ImageCapture = 6508,
  ImageCaptureError = 6521,
  ImageCaptureErrorEvent = 6539,
  ImageData = 6562,
  ImageDocument = 6572,
  InputEvent = 6586,
  InspectorFontFace = 6597,
  InspectorUtils = 6615,
  InstallTriggerImpl = 6630,
  IntersectionObserver = 6649,
  IntersectionObserverEntry = 6670,
  IntlUtils = 6696,
  JSProcessActorChild = 6706,
  JSProcessActorParent = 6726,
  JSWindowActorChild = 6747,
  JSWindowActorParent = 6766,
  KeyEvent = 6786,
  KeyboardEvent = 6795,
  KeyframeEffect = 6809,
  L10nFileSource = 6824,
  L10nOverlays = 6839,
  L10nRegistry = 6852,
  LegacyMozTCPSocket = 6865,
  Localization = 6884,
  Location = 6897,
  Lock = 6906,
  LockManager = 6911,
  MIDIAccess = 6923,
  MIDIConnectionEvent = 6934,
  MIDIInput = 6954,
  MIDIInputMap = 6964,
  MIDIMessageEvent = 6977,
  MIDIOutput = 6994,
  MIDIOutputMap = 7005,
  MIDIPort = 7019,
  MOZ_debug = 7028,
  MatchGlob = 7038,
  MatchPattern = 7048,
  MatchPatternSet = 7061,
  MathMLElement = 7077,
  MediaCapabilities = 7091,
  MediaCapabilitiesInfo = 7109,
  MediaControlService = 7131,
  MediaController = 7151,
  MediaDeviceInfo = 7167,
  MediaDevices = 7183,
  MediaElementAudioSourceNode = 7196,
  MediaEncryptedEvent = 7224,
  MediaError = 7244,
  MediaKeyError = 7255,
  MediaKeyMessageEvent = 7269,
  MediaKeySession = 7290,
  MediaKeyStatusMap = 7306,
  MediaKeyStatusMap_Iterator = 7324,
  MediaKeySystemAccess = 7351,
  MediaKeys = 7372,
  MediaList = 7382,
  MediaMetadata = 7392,
  MediaQueryList = 7406,
  MediaQueryListEvent = 7421,
  MediaRecorder = 7441,
  MediaRecorderErrorEvent = 7455,
  MediaSession = 7479,
  MediaSource = 7492,
  MediaStream = 7504,
  MediaStreamAudioDestinationNode = 7516,
  MediaStreamAudioSourceNode = 7548,
  MediaStreamError = 7575,
  MediaStreamEvent = 7592,
  MediaStreamTrack = 7609,
  MediaStreamTrackAudioSourceNode = 7626,
  MediaStreamTrackEvent = 7658,
  MerchantValidationEvent = 7680,
  MessageBroadcaster = 7704,
  MessageChannel = 7723,
  MessageEvent = 7738,
  MessageListenerManager = 7751,
  MessagePort = 7774,
  MessageSender = 7786,
  MimeType = 7800,
  MimeTypeArray = 7809,
  MouseEvent = 7823,
  MouseScrollEvent = 7834,
  MozCanvasPrintState = 7851,
  MozDocumentMatcher = 7871,
  MozDocumentObserver = 7890,
  MozQueryInterface = 7910,
  MozSharedMap = 7928,
  MozSharedMap_Iterator = 7941,
  MozSharedMapChangeEvent = 7963,
  MozStorageAsyncStatementParams = 7987,
  MozStorageStatementParams = 8018,
  MozStorageStatementRow = 8044,
  MozWritableSharedMap = 8067,
  MutationEvent = 8088,
  MutationObserver = 8102,
  MutationRecord = 8119,
  NamedNodeMap = 8134,
  NavigationPreloadManager = 8147,
  Navigator = 8172,
  NetworkInformation = 8182,
  Node = 8201,
  NodeFilter = 8206,
  NodeIterator = 8217,
  NodeList = 8230,
  Notification = 8239,
  NotificationEvent = 8252,
  NotifyPaintEvent = 8270,
  OES_draw_buffers_indexed = 8287,
  OES_element_index_uint = 8312,
  OES_fbo_render_mipmap = 8335,
  OES_standard_derivatives = 8357,
  OES_texture_float = 8382,
  OES_texture_float_linear = 8400,
  OES_texture_half_float = 8425,
  OES_texture_half_float_linear = 8448,
  OES_vertex_array_object = 8478,
  OVR_multiview2 = 8502,
  OfflineAudioCompletionEvent = 8517,
  OfflineAudioContext = 8545,
  OfflineResourceList = 8565,
  OffscreenCanvas = 8585,
  OffscreenCanvasRenderingContext2D = 8601,
  Option = 8635,
  OscillatorNode = 8642,
  PageTransitionEvent = 8657,
  PaintRequest = 8677,
  PaintRequestList = 8690,
  PaintWorkletGlobalScope = 8707,
  PannerNode = 8731,
  ParentProcessMessageManager = 8742,
  Path2D = 8770,
  PathUtils = 8777,
  PaymentAddress = 8787,
  PaymentMethodChangeEvent = 8802,
  PaymentRequest = 8827,
  PaymentRequestUpdateEvent = 8842,
  PaymentResponse = 8868,
  Performance = 8884,
  PerformanceEntry = 8896,
  PerformanceEntryEvent = 8913,
  PerformanceEventTiming = 8935,
  PerformanceMark = 8958,
  PerformanceMeasure = 8974,
  PerformanceNavigation = 8993,
  PerformanceNavigationTiming = 9015,
  PerformanceObserver = 9043,
  PerformanceObserverEntryList = 9063,
  PerformancePaintTiming = 9092,
  PerformanceResourceTiming = 9115,
  PerformanceServerTiming = 9141,
  PerformanceTiming = 9165,
  PeriodicWave = 9183,
  PermissionStatus = 9196,
  Permissions = 9213,
  PlacesBookmark = 9225,
  PlacesBookmarkAddition = 9240,
  PlacesBookmarkChanged = 9263,
  PlacesBookmarkGuid = 9285,
  PlacesBookmarkMoved = 9304,
  PlacesBookmarkRemoved = 9324,
  PlacesBookmarkTags = 9346,
  PlacesBookmarkTime = 9365,
  PlacesBookmarkTitle = 9384,
  PlacesBookmarkUrl = 9404,
  PlacesEvent = 9422,
  PlacesFavicon = 9434,
  PlacesHistoryCleared = 9448,
  PlacesObservers = 9469,
  PlacesPurgeCaches = 9485,
  PlacesRanking = 9503,
  PlacesVisit = 9517,
  PlacesVisitRemoved = 9529,
  PlacesVisitTitle = 9548,
  PlacesWeakCallbackWrapper = 9565,
  Plugin = 9591,
  PluginArray = 9598,
  PluginCrashedEvent = 9610,
  PointerEvent = 9629,
  PopStateEvent = 9642,
  PopupBlockedEvent = 9656,
  PopupPositionedEvent = 9674,
  PositionStateEvent = 9695,
  PrecompiledScript = 9714,
  PrioEncoder = 9732,
  ProcessMessageManager = 9744,
  ProcessingInstruction = 9766,
  ProgressEvent = 9788,
  PromiseDebugging = 9802,
  PromiseNativeHandler = 9819,
  PromiseRejectionEvent = 9840,
  PublicKeyCredential = 9862,
  PushEvent = 9882,
  PushManager = 9892,
  PushManagerImpl = 9904,
  PushMessageData = 9920,
  PushSubscription = 9936,
  PushSubscriptionOptions = 9953,
  RadioNodeList = 9977,
  Range = 9991,
  ReadableByteStreamController = 9997,
  ReadableStream = 10026,
  ReadableStreamBYOBReader = 10041,
  ReadableStreamBYOBRequest = 10066,
  ReadableStreamDefaultController = 10092,
  ReadableStreamDefaultReader = 10124,
  Report = 10152,
  ReportBody = 10159,
  ReportingObserver = 10170,
  Request = 10188,
  ResizeObserver = 10196,
  ResizeObserverEntry = 10211,
  ResizeObserverSize = 10231,
  Response = 10250,
  SVGAElement = 10259,
  SVGAngle = 10271,
  SVGAnimateElement = 10280,
  SVGAnimateMotionElement = 10298,
  SVGAnimateTransformElement = 10322,
  SVGAnimatedAngle = 10349,
  SVGAnimatedBoolean = 10366,
  SVGAnimatedEnumeration = 10385,
  SVGAnimatedInteger = 10408,
  SVGAnimatedLength = 10427,
  SVGAnimatedLengthList = 10445,
  SVGAnimatedNumber = 10467,
  SVGAnimatedNumberList = 10485,
  SVGAnimatedPreserveAspectRatio = 10507,
  SVGAnimatedRect = 10538,
  SVGAnimatedString = 10554,
  SVGAnimatedTransformList = 10572,
  SVGAnimationElement = 10597,
  SVGCircleElement = 10617,
  SVGClipPathElement = 10634,
  SVGComponentTransferFunctionElement = 10653,
  SVGDefsElement = 10689,
  SVGDescElement = 10704,
  SVGElement = 10719,
  SVGEllipseElement = 10730,
  SVGFEBlendElement = 10748,
  SVGFEColorMatrixElement = 10766,
  SVGFEComponentTransferElement = 10790,
  SVGFECompositeElement = 10820,
  SVGFEConvolveMatrixElement = 10842,
  SVGFEDiffuseLightingElement = 10869,
  SVGFEDisplacementMapElement = 10897,
  SVGFEDistantLightElement = 10925,
  SVGFEDropShadowElement = 10950,
  SVGFEFloodElement = 10973,
  SVGFEFuncAElement = 10991,
  SVGFEFuncBElement = 11009,
  SVGFEFuncGElement = 11027,
  SVGFEFuncRElement = 11045,
  SVGFEGaussianBlurElement = 11063,
  SVGFEImageElement = 11088,
  SVGFEMergeElement = 11106,
  SVGFEMergeNodeElement = 11124,
  SVGFEMorphologyElement = 11146,
  SVGFEOffsetElement = 11169,
  SVGFEPointLightElement = 11188,
  SVGFESpecularLightingElement = 11211,
  SVGFESpotLightElement = 11240,
  SVGFETileElement = 11262,
  SVGFETurbulenceElement = 11279,
  SVGFilterElement = 11302,
  SVGForeignObjectElement = 11319,
  SVGGElement = 11343,
  SVGGeometryElement = 11355,
  SVGGradientElement = 11374,
  SVGGraphicsElement = 11393,
  SVGImageElement = 11412,
  SVGLength = 11428,
  SVGLengthList = 11438,
  SVGLineElement = 11452,
  SVGLinearGradientElement = 11467,
  SVGMPathElement = 11492,
  SVGMarkerElement = 11508,
  SVGMaskElement = 11525,
  SVGMatrix = 11540,
  SVGMetadataElement = 11550,
  SVGNumber = 11569,
  SVGNumberList = 11579,
  SVGPathElement = 11593,
  SVGPathSeg = 11608,
  SVGPathSegArcAbs = 11619,
  SVGPathSegArcRel = 11636,
  SVGPathSegClosePath = 11653,
  SVGPathSegCurvetoCubicAbs = 11673,
  SVGPathSegCurvetoCubicRel = 11699,
  SVGPathSegCurvetoCubicSmoothAbs = 11725,
  SVGPathSegCurvetoCubicSmoothRel = 11757,
  SVGPathSegCurvetoQuadraticAbs = 11789,
  SVGPathSegCurvetoQuadraticRel = 11819,
  SVGPathSegCurvetoQuadraticSmoothAbs = 11849,
  SVGPathSegCurvetoQuadraticSmoothRel = 11885,
  SVGPathSegLinetoAbs = 11921,
  SVGPathSegLinetoHorizontalAbs = 11941,
  SVGPathSegLinetoHorizontalRel = 11971,
  SVGPathSegLinetoRel = 12001,
  SVGPathSegLinetoVerticalAbs = 12021,
  SVGPathSegLinetoVerticalRel = 12049,
  SVGPathSegList = 12077,
  SVGPathSegMovetoAbs = 12092,
  SVGPathSegMovetoRel = 12112,
  SVGPatternElement = 12132,
  SVGPoint = 12150,
  SVGPointList = 12159,
  SVGPolygonElement = 12172,
  SVGPolylineElement = 12190,
  SVGPreserveAspectRatio = 12209,
  SVGRadialGradientElement = 12232,
  SVGRect = 12257,
  SVGRectElement = 12265,
  SVGSVGElement = 12280,
  SVGScriptElement = 12294,
  SVGSetElement = 12311,
  SVGStopElement = 12325,
  SVGStringList = 12340,
  SVGStyleElement = 12354,
  SVGSwitchElement = 12370,
  SVGSymbolElement = 12387,
  SVGTSpanElement = 12404,
  SVGTextContentElement = 12420,
  SVGTextElement = 12442,
  SVGTextPathElement = 12457,
  SVGTextPositioningElement = 12476,
  SVGTitleElement = 12502,
  SVGTransform = 12518,
  SVGTransformList = 12531,
  SVGUnitTypes = 12548,
  SVGUseElement = 12561,
  SVGViewElement = 12575,
  Sanitizer = 12590,
  Scheduler = 12600,
  Screen = 12610,
  ScreenLuminance = 12617,
  ScreenOrientation = 12633,
  ScriptProcessorNode = 12651,
  ScrollAreaEvent = 12671,
  ScrollViewChangeEvent = 12687,
  SecurityPolicyViolationEvent = 12709,
  Selection = 12738,
  ServiceWorker = 12748,
  ServiceWorkerContainer = 12762,
  ServiceWorkerGlobalScope = 12785,
  ServiceWorkerRegistration = 12810,
  SessionStoreFormData = 12836,
  SessionStoreScrollData = 12857,
  SessionStoreUtils = 12880,
  ShadowRealmGlobalScope = 12898,
  ShadowRoot = 12921,
  SharedWorker = 12932,
  SharedWorkerGlobalScope = 12945,
  SimpleGestureEvent = 12969,
  SourceBuffer = 12988,
  SourceBufferList = 13001,
  SpeechGrammar = 13018,
  SpeechGrammarList = 13032,
  SpeechRecognition = 13050,
  SpeechRecognitionAlternative = 13068,
  SpeechRecognitionError = 13097,
  SpeechRecognitionEvent = 13120,
  SpeechRecognitionResult = 13143,
  SpeechRecognitionResultList = 13167,
  SpeechSynthesis = 13195,
  SpeechSynthesisErrorEvent = 13211,
  SpeechSynthesisEvent = 13237,
  SpeechSynthesisUtterance = 13258,
  SpeechSynthesisVoice = 13283,
  StaticRange = 13304,
  StereoPannerNode = 13316,
  Storage = 13333,
  StorageEvent = 13341,
  StorageManager = 13354,
  StreamFilter = 13369,
  StreamFilterDataEvent = 13382,
  StructuredCloneHolder = 13404,
  StructuredCloneTester = 13426,
  StyleSheet = 13448,
  StyleSheetApplicableStateChangeEvent = 13459,
  StyleSheetList = 13496,
  SubmitEvent = 13511,
  SubtleCrypto = 13523,
  SyncMessageSender = 13536,
  SyncReadFile = 13554,
  TCPServerSocket = 13567,
  TCPServerSocketEvent = 13583,
  TCPSocket = 13604,
  TCPSocketErrorEvent = 13614,
  TCPSocketEvent = 13634,
  TaskController = 13649,
  TaskPriorityChangeEvent = 13664,
  TaskSignal = 13688,
  TelemetryStopwatch = 13699,
  TestUtils = 13718,
  TestingDeprecatedInterface = 13728,
  Text = 13755,
  TextClause = 13760,
  TextDecoder = 13771,
  TextDecoderStream = 13783,
  TextEncoder = 13801,
  TextEncoderStream = 13813,
  TextMetrics = 13831,
  TextTrack = 13843,
  TextTrackCue = 13853,
  TextTrackCueList = 13866,
  TextTrackList = 13883,
  TimeEvent = 13897,
  TimeRanges = 13907,
  Touch = 13918,
  TouchEvent = 13924,
  TouchList = 13935,
  TrackEvent = 13945,
  TransformStream = 13956,
  TransformStreamDefaultController = 13972,
  TransitionEvent = 14005,
  TreeColumn = 14021,
  TreeColumns = 14032,
  TreeContentView = 14044,
  TreeWalker = 14060,
  U2F = 14071,
  UDPMessageEvent = 14075,
  UDPSocket = 14091,
  UIEvent = 14101,
  URL = 14109,
  URLSearchParams = 14113,
  URLSearchParams_Iterator = 14129,
  UniFFIPointer = 14154,
  UniFFIScaffolding = 14168,
  UserInteraction = 14186,
  UserProximityEvent = 14202,
  VRDisplay = 14221,
  VRDisplayCapabilities = 14231,
  VRDisplayEvent = 14253,
  VREyeParameters = 14268,
  VRFieldOfView = 14284,
  VRFrameData = 14298,
  VRMockController = 14310,
  VRMockDisplay = 14327,
  VRPose = 14341,
  VRServiceTest = 14348,
  VRStageParameters = 14362,
  VTTCue = 14380,
  VTTRegion = 14387,
  ValidityState = 14397,
  VideoPlaybackQuality = 14411,
  VideoTrack = 14432,
  VideoTrackList = 14443,
  VisualViewport = 14458,
  WEBGL_color_buffer_float = 14473,
  WEBGL_compressed_texture_astc = 14498,
  WEBGL_compressed_texture_etc = 14528,
  WEBGL_compressed_texture_etc1 = 14557,
  WEBGL_compressed_texture_pvrtc = 14587,
  WEBGL_compressed_texture_s3tc = 14618,
  WEBGL_compressed_texture_s3tc_srgb = 14648,
  WEBGL_debug_renderer_info = 14683,
  WEBGL_debug_shaders = 14709,
  WEBGL_depth_texture = 14729,
  WEBGL_draw_buffers = 14749,
  WEBGL_explicit_present = 14768,
  WEBGL_lose_context = 14791,
  WaveShaperNode = 14810,
  WebExtensionContentScript = 14825,
  WebExtensionPolicy = 14851,
  WebGL2RenderingContext = 14870,
  WebGLActiveInfo = 14893,
  WebGLBuffer = 14909,
  WebGLContextEvent = 14921,
  WebGLFramebuffer = 14939,
  WebGLProgram = 14956,
  WebGLQuery = 14969,
  WebGLRenderbuffer = 14980,
  WebGLRenderingContext = 14998,
  WebGLSampler = 15020,
  WebGLShader = 15033,
  WebGLShaderPrecisionFormat = 15045,
  WebGLSync = 15072,
  WebGLTexture = 15082,
  WebGLTransformFeedback = 15095,
  WebGLUniformLocation = 15118,
  WebGLVertexArrayObject = 15139,
  WebKitCSSMatrix = 15162,
  WebSocket = 15178,
  WheelEvent = 15188,
  Window = 15199,
  WindowClient = 15206,
  WindowContext = 15219,
  WindowGlobalChild = 15233,
  WindowGlobalParent = 15251,
  WindowRoot = 15270,
  Worker = 15281,
  WorkerDebuggerGlobalScope = 15288,
  WorkerGlobalScope = 15314,
  WorkerLocation = 15332,
  WorkerNavigator = 15347,
  WorkerTestUtils = 15363,
  Worklet = 15379,
  WorkletGlobalScope = 15387,
  WritableStream = 15406,
  WritableStreamDefaultController = 15421,
  WritableStreamDefaultWriter = 15453,
  XMLDocument = 15481,
  XMLHttpRequest = 15493,
  XMLHttpRequestEventTarget = 15508,
  XMLHttpRequestUpload = 15534,
  XMLSerializer = 15555,
  XPathEvaluator = 15569,
  XPathExpression = 15584,
  XPathResult = 15600,
  XRBoundedReferenceSpace = 15612,
  XRFrame = 15636,
  XRInputSource = 15644,
  XRInputSourceArray = 15658,
  XRInputSourceEvent = 15677,
  XRInputSourcesChangeEvent = 15696,
  XRPose = 15722,
  XRReferenceSpace = 15729,
  XRReferenceSpaceEvent = 15746,
  XRRenderState = 15768,
  XRRigidTransform = 15782,
  XRSession = 15799,
  XRSessionEvent = 15809,
  XRSpace = 15824,
  XRSystem = 15832,
  XRView = 15841,
  XRViewerPose = 15848,
  XRViewport = 15861,
  XRWebGLLayer = 15872,
  XSLTProcessor = 15885,
  XULCommandEvent = 15899,
  XULElement = 15915,
  XULFrameElement = 15926,
  XULMenuElement = 15942,
  XULPopupElement = 15957,
  XULResizerElement = 15973,
  XULTextElement = 15991,
  XULTreeElement = 16006,
  console = 16021,
  webkitSpeechGrammar = 16029,
  webkitSpeechGrammarList = 16049,
  webkitSpeechRecognition = 16073,
  webkitURL = 16097,
};

namespace binding_detail {
extern const char sBindingNames[];
}  // namespace binding_detail

MOZ_ALWAYS_INLINE const char* BindingName(BindingNamesOffset aOffset) {
  return binding_detail::sBindingNames + static_cast<size_t>(aOffset);
}

} // namespace mozilla::dom


#endif // mozilla_dom_BindingNames_h
