#include "mozilla/EnumTypeTraits.h"
#include "mozilla/dom/BindingNames.h"

namespace mozilla::dom {

namespace binding_detail {

const char sBindingNames[] = {
  /*     0 */ "ANGLE_instanced_arrays" "\0"
  /*    23 */ "APZHitResultFlags" "\0"
  /*    41 */ "AbortController" "\0"
  /*    57 */ "AbortSignal" "\0"
  /*    69 */ "AbstractRange" "\0"
  /*    83 */ "AccessibleNode" "\0"
  /*    98 */ "Addon" "\0"
  /*   104 */ "AddonEvent" "\0"
  /*   115 */ "AddonInstall" "\0"
  /*   128 */ "AddonManager" "\0"
  /*   141 */ "AddonManagerPermissions" "\0"
  /*   165 */ "AnalyserNode" "\0"
  /*   178 */ "Animation" "\0"
  /*   188 */ "AnimationEffect" "\0"
  /*   204 */ "AnimationEvent" "\0"
  /*   219 */ "AnimationPlaybackEvent" "\0"
  /*   242 */ "AnimationTimeline" "\0"
  /*   260 */ "AnonymousContent" "\0"
  /*   277 */ "Attr" "\0"
  /*   282 */ "Audio" "\0"
  /*   288 */ "AudioBuffer" "\0"
  /*   300 */ "AudioBufferSourceNode" "\0"
  /*   322 */ "AudioContext" "\0"
  /*   335 */ "AudioDestinationNode" "\0"
  /*   356 */ "AudioListener" "\0"
  /*   370 */ "AudioNode" "\0"
  /*   380 */ "AudioParam" "\0"
  /*   391 */ "AudioParamMap" "\0"
  /*   405 */ "AudioProcessingEvent" "\0"
  /*   426 */ "AudioScheduledSourceNode" "\0"
  /*   451 */ "AudioTrack" "\0"
  /*   462 */ "AudioTrackList" "\0"
  /*   477 */ "AudioWorklet" "\0"
  /*   490 */ "AudioWorkletGlobalScope" "\0"
  /*   514 */ "AudioWorkletNode" "\0"
  /*   531 */ "AudioWorkletProcessor" "\0"
  /*   553 */ "AuthenticatorAssertionResponse" "\0"
  /*   584 */ "AuthenticatorAttestationResponse" "\0"
  /*   617 */ "AuthenticatorResponse" "\0"
  /*   639 */ "BarProp" "\0"
  /*   647 */ "BaseAudioContext" "\0"
  /*   664 */ "BatteryManager" "\0"
  /*   679 */ "BeforeUnloadEvent" "\0"
  /*   697 */ "BiquadFilterNode" "\0"
  /*   714 */ "Blob" "\0"
  /*   719 */ "BlobEvent" "\0"
  /*   729 */ "BroadcastChannel" "\0"
  /*   746 */ "BrowsingContext" "\0"
  /*   762 */ "BrowsingContextGroup" "\0"
  /*   783 */ "ByteLengthQueuingStrategy" "\0"
  /*   809 */ "CDATASection" "\0"
  /*   822 */ "CSS" "\0"
  /*   826 */ "CSS2Properties" "\0"
  /*   841 */ "CSSAnimation" "\0"
  /*   854 */ "CSSConditionRule" "\0"
  /*   871 */ "CSSContainerRule" "\0"
  /*   888 */ "CSSCounterStyleRule" "\0"
  /*   908 */ "CSSFontFaceRule" "\0"
  /*   924 */ "CSSFontFeatureValuesRule" "\0"
  /*   949 */ "CSSGroupingRule" "\0"
  /*   965 */ "CSSImportRule" "\0"
  /*   979 */ "CSSKeyframeRule" "\0"
  /*   995 */ "CSSKeyframesRule" "\0"
  /*  1012 */ "CSSLayerBlockRule" "\0"
  /*  1030 */ "CSSLayerStatementRule" "\0"
  /*  1052 */ "CSSMediaRule" "\0"
  /*  1065 */ "CSSMozDocumentRule" "\0"
  /*  1084 */ "CSSNamespaceRule" "\0"
  /*  1101 */ "CSSPageRule" "\0"
  /*  1113 */ "CSSPseudoElement" "\0"
  /*  1130 */ "CSSRule" "\0"
  /*  1138 */ "CSSRuleList" "\0"
  /*  1150 */ "CSSScrollTimelineRule" "\0"
  /*  1172 */ "CSSStyleDeclaration" "\0"
  /*  1192 */ "CSSStyleRule" "\0"
  /*  1205 */ "CSSStyleSheet" "\0"
  /*  1219 */ "CSSSupportsRule" "\0"
  /*  1235 */ "CSSTransition" "\0"
  /*  1249 */ "Cache" "\0"
  /*  1255 */ "CacheStorage" "\0"
  /*  1268 */ "CallbackDebuggerNotification" "\0"
  /*  1297 */ "CanonicalBrowsingContext" "\0"
  /*  1322 */ "CanvasCaptureMediaStream" "\0"
  /*  1347 */ "CanvasGradient" "\0"
  /*  1362 */ "CanvasPattern" "\0"
  /*  1376 */ "CanvasRenderingContext2D" "\0"
  /*  1401 */ "CaretPosition" "\0"
  /*  1415 */ "CaretStateChangedEvent" "\0"
  /*  1438 */ "ChannelMergerNode" "\0"
  /*  1456 */ "ChannelSplitterNode" "\0"
  /*  1476 */ "ChannelWrapper" "\0"
  /*  1491 */ "CharacterData" "\0"
  /*  1505 */ "CheckerboardReportService" "\0"
  /*  1531 */ "ChildProcessMessageManager" "\0"
  /*  1558 */ "ChildSHistory" "\0"
  /*  1572 */ "ChromeMessageBroadcaster" "\0"
  /*  1597 */ "ChromeMessageSender" "\0"
  /*  1617 */ "ChromeNodeList" "\0"
  /*  1632 */ "ChromeUtils" "\0"
  /*  1644 */ "ChromeWorker" "\0"
  /*  1657 */ "Client" "\0"
  /*  1664 */ "Clients" "\0"
  /*  1672 */ "Clipboard" "\0"
  /*  1682 */ "ClipboardEvent" "\0"
  /*  1697 */ "ClipboardItem" "\0"
  /*  1711 */ "ClonedErrorHolder" "\0"
  /*  1729 */ "CloseEvent" "\0"
  /*  1740 */ "CommandEvent" "\0"
  /*  1753 */ "Comment" "\0"
  /*  1761 */ "CompositionEvent" "\0"
  /*  1778 */ "ConsoleInstance" "\0"
  /*  1794 */ "ConstantSourceNode" "\0"
  /*  1813 */ "ContentFrameMessageManager" "\0"
  /*  1840 */ "ContentProcessMessageManager" "\0"
  /*  1869 */ "ConvolverNode" "\0"
  /*  1883 */ "CountQueuingStrategy" "\0"
  /*  1904 */ "CreateOfferRequest" "\0"
  /*  1923 */ "Credential" "\0"
  /*  1934 */ "CredentialsContainer" "\0"
  /*  1955 */ "Crypto" "\0"
  /*  1962 */ "CryptoKey" "\0"
  /*  1972 */ "CustomElementRegistry" "\0"
  /*  1994 */ "CustomEvent" "\0"
  /*  2006 */ "DOMException" "\0"
  /*  2019 */ "DOMImplementation" "\0"
  /*  2037 */ "DOMLocalization" "\0"
  /*  2053 */ "DOMMatrix" "\0"
  /*  2063 */ "DOMMatrixReadOnly" "\0"
  /*  2081 */ "DOMParser" "\0"
  /*  2091 */ "DOMPoint" "\0"
  /*  2100 */ "DOMPointReadOnly" "\0"
  /*  2117 */ "DOMQuad" "\0"
  /*  2125 */ "DOMRect" "\0"
  /*  2133 */ "DOMRectList" "\0"
  /*  2145 */ "DOMRectReadOnly" "\0"
  /*  2161 */ "DOMRequest" "\0"
  /*  2172 */ "DOMStringList" "\0"
  /*  2186 */ "DOMStringMap" "\0"
  /*  2199 */ "DOMTokenList" "\0"
  /*  2212 */ "DataTransfer" "\0"
  /*  2225 */ "DataTransferItem" "\0"
  /*  2242 */ "DataTransferItemList" "\0"
  /*  2263 */ "DebuggerNotification" "\0"
  /*  2284 */ "DebuggerNotificationObserver" "\0"
  /*  2313 */ "DedicatedWorkerGlobalScope" "\0"
  /*  2340 */ "DelayNode" "\0"
  /*  2350 */ "DeprecationReportBody" "\0"
  /*  2372 */ "DeviceAcceleration" "\0"
  /*  2391 */ "DeviceLightEvent" "\0"
  /*  2408 */ "DeviceMotionEvent" "\0"
  /*  2426 */ "DeviceOrientationEvent" "\0"
  /*  2449 */ "DeviceRotationRate" "\0"
  /*  2468 */ "Directory" "\0"
  /*  2478 */ "Document" "\0"
  /*  2487 */ "DocumentFragment" "\0"
  /*  2504 */ "DocumentL10n" "\0"
  /*  2517 */ "DocumentTimeline" "\0"
  /*  2534 */ "DocumentType" "\0"
  /*  2547 */ "DominatorTree" "\0"
  /*  2561 */ "DragEvent" "\0"
  /*  2571 */ "DynamicsCompressorNode" "\0"
  /*  2594 */ "EXT_blend_minmax" "\0"
  /*  2611 */ "EXT_color_buffer_float" "\0"
  /*  2634 */ "EXT_color_buffer_half_float" "\0"
  /*  2662 */ "EXT_disjoint_timer_query" "\0"
  /*  2687 */ "EXT_float_blend" "\0"
  /*  2703 */ "EXT_frag_depth" "\0"
  /*  2718 */ "EXT_sRGB" "\0"
  /*  2727 */ "EXT_shader_texture_lod" "\0"
  /*  2750 */ "EXT_texture_compression_bptc" "\0"
  /*  2779 */ "EXT_texture_compression_rgtc" "\0"
  /*  2808 */ "EXT_texture_filter_anisotropic" "\0"
  /*  2839 */ "EXT_texture_norm16" "\0"
  /*  2858 */ "Element" "\0"
  /*  2866 */ "ElementInternals" "\0"
  /*  2883 */ "ErrorEvent" "\0"
  /*  2894 */ "Event" "\0"
  /*  2900 */ "EventCallbackDebuggerNotification" "\0"
  /*  2934 */ "EventCounts" "\0"
  /*  2946 */ "EventSource" "\0"
  /*  2958 */ "EventTarget" "\0"
  /*  2970 */ "Exception" "\0"
  /*  2980 */ "ExtendableEvent" "\0"
  /*  2996 */ "ExtendableMessageEvent" "\0"
  /*  3019 */ "ExtensionAlarms" "\0"
  /*  3035 */ "ExtensionBrowser" "\0"
  /*  3052 */ "ExtensionEventManager" "\0"
  /*  3074 */ "ExtensionMockAPI" "\0"
  /*  3091 */ "ExtensionPort" "\0"
  /*  3105 */ "ExtensionRuntime" "\0"
  /*  3122 */ "ExtensionScripting" "\0"
  /*  3141 */ "ExtensionTest" "\0"
  /*  3155 */ "External" "\0"
  /*  3164 */ "FeaturePolicy" "\0"
  /*  3178 */ "FeaturePolicyViolationReportBody" "\0"
  /*  3211 */ "FetchEvent" "\0"
  /*  3222 */ "FetchObserver" "\0"
  /*  3236 */ "File" "\0"
  /*  3241 */ "FileList" "\0"
  /*  3250 */ "FileReader" "\0"
  /*  3261 */ "FileReaderSync" "\0"
  /*  3276 */ "FileSystem" "\0"
  /*  3287 */ "FileSystemDirectoryEntry" "\0"
  /*  3312 */ "FileSystemDirectoryHandle" "\0"
  /*  3338 */ "FileSystemDirectoryHandle AsyncIterator" "\0"
  /*  3378 */ "FileSystemDirectoryIterator" "\0"
  /*  3406 */ "FileSystemDirectoryReader" "\0"
  /*  3432 */ "FileSystemEntry" "\0"
  /*  3448 */ "FileSystemFileEntry" "\0"
  /*  3468 */ "FileSystemFileHandle" "\0"
  /*  3489 */ "FileSystemHandle" "\0"
  /*  3506 */ "FileSystemSyncAccessHandle" "\0"
  /*  3533 */ "FileSystemWritableFileStream" "\0"
  /*  3562 */ "Flex" "\0"
  /*  3567 */ "FlexItemValues" "\0"
  /*  3582 */ "FlexLineValues" "\0"
  /*  3597 */ "FluentBundle" "\0"
  /*  3610 */ "FluentBundleAsyncIterator" "\0"
  /*  3636 */ "FluentBundleIterator" "\0"
  /*  3657 */ "FluentPattern" "\0"
  /*  3671 */ "FluentResource" "\0"
  /*  3686 */ "FocusEvent" "\0"
  /*  3697 */ "FontFace" "\0"
  /*  3706 */ "FontFaceSet" "\0"
  /*  3718 */ "FontFaceSetIterator" "\0"
  /*  3738 */ "FontFaceSetLoadEvent" "\0"
  /*  3759 */ "FormData" "\0"
  /*  3768 */ "FormData Iterator" "\0"
  /*  3786 */ "FormDataEvent" "\0"
  /*  3800 */ "FrameCrashedEvent" "\0"
  /*  3818 */ "FrameLoader" "\0"
  /*  3830 */ "GPU" "\0"
  /*  3834 */ "GPUAdapter" "\0"
  /*  3845 */ "GPUBindGroup" "\0"
  /*  3858 */ "GPUBindGroupLayout" "\0"
  /*  3877 */ "GPUBuffer" "\0"
  /*  3887 */ "GPUBufferUsage" "\0"
  /*  3902 */ "GPUCanvasContext" "\0"
  /*  3919 */ "GPUColorWrite" "\0"
  /*  3933 */ "GPUCommandBuffer" "\0"
  /*  3950 */ "GPUCommandEncoder" "\0"
  /*  3968 */ "GPUCompilationInfo" "\0"
  /*  3987 */ "GPUCompilationMessage" "\0"
  /*  4009 */ "GPUComputePassEncoder" "\0"
  /*  4031 */ "GPUComputePipeline" "\0"
  /*  4050 */ "GPUDevice" "\0"
  /*  4060 */ "GPUDeviceLostInfo" "\0"
  /*  4078 */ "GPUMapMode" "\0"
  /*  4089 */ "GPUOutOfMemoryError" "\0"
  /*  4109 */ "GPUPipelineLayout" "\0"
  /*  4127 */ "GPUQuerySet" "\0"
  /*  4139 */ "GPUQueue" "\0"
  /*  4148 */ "GPURenderBundle" "\0"
  /*  4164 */ "GPURenderBundleEncoder" "\0"
  /*  4187 */ "GPURenderPassEncoder" "\0"
  /*  4208 */ "GPURenderPipeline" "\0"
  /*  4226 */ "GPUSampler" "\0"
  /*  4237 */ "GPUShaderModule" "\0"
  /*  4253 */ "GPUShaderStage" "\0"
  /*  4268 */ "GPUSupportedFeatures" "\0"
  /*  4289 */ "GPUSupportedLimits" "\0"
  /*  4308 */ "GPUTexture" "\0"
  /*  4319 */ "GPUTextureUsage" "\0"
  /*  4335 */ "GPUTextureView" "\0"
  /*  4350 */ "GPUUncapturedErrorEvent" "\0"
  /*  4374 */ "GPUValidationError" "\0"
  /*  4393 */ "GainNode" "\0"
  /*  4402 */ "Gamepad" "\0"
  /*  4410 */ "GamepadAxisMoveEvent" "\0"
  /*  4431 */ "GamepadButton" "\0"
  /*  4445 */ "GamepadButtonEvent" "\0"
  /*  4464 */ "GamepadEvent" "\0"
  /*  4477 */ "GamepadHapticActuator" "\0"
  /*  4499 */ "GamepadLightIndicator" "\0"
  /*  4521 */ "GamepadPose" "\0"
  /*  4533 */ "GamepadServiceTest" "\0"
  /*  4552 */ "GamepadTouch" "\0"
  /*  4565 */ "Geolocation" "\0"
  /*  4577 */ "GeolocationCoordinates" "\0"
  /*  4600 */ "GeolocationPosition" "\0"
  /*  4620 */ "GeolocationPositionError" "\0"
  /*  4645 */ "GetUserMediaRequest" "\0"
  /*  4665 */ "GleanCategory" "\0"
  /*  4679 */ "GleanImpl" "\0"
  /*  4689 */ "GleanLabeled" "\0"
  /*  4702 */ "GleanPingsImpl" "\0"
  /*  4717 */ "Grid" "\0"
  /*  4722 */ "GridArea" "\0"
  /*  4731 */ "GridDimension" "\0"
  /*  4745 */ "GridLine" "\0"
  /*  4754 */ "GridLines" "\0"
  /*  4764 */ "GridTrack" "\0"
  /*  4774 */ "GridTracks" "\0"
  /*  4785 */ "HTMLAllCollection" "\0"
  /*  4803 */ "HTMLAnchorElement" "\0"
  /*  4821 */ "HTMLAreaElement" "\0"
  /*  4837 */ "HTMLAudioElement" "\0"
  /*  4854 */ "HTMLBRElement" "\0"
  /*  4868 */ "HTMLBaseElement" "\0"
  /*  4884 */ "HTMLBodyElement" "\0"
  /*  4900 */ "HTMLButtonElement" "\0"
  /*  4918 */ "HTMLCanvasElement" "\0"
  /*  4936 */ "HTMLCollection" "\0"
  /*  4951 */ "HTMLDListElement" "\0"
  /*  4968 */ "HTMLDataElement" "\0"
  /*  4984 */ "HTMLDataListElement" "\0"
  /*  5004 */ "HTMLDetailsElement" "\0"
  /*  5023 */ "HTMLDialogElement" "\0"
  /*  5041 */ "HTMLDirectoryElement" "\0"
  /*  5062 */ "HTMLDivElement" "\0"
  /*  5077 */ "HTMLDocument" "\0"
  /*  5090 */ "HTMLElement" "\0"
  /*  5102 */ "HTMLEmbedElement" "\0"
  /*  5119 */ "HTMLFieldSetElement" "\0"
  /*  5139 */ "HTMLFontElement" "\0"
  /*  5155 */ "HTMLFormControlsCollection" "\0"
  /*  5182 */ "HTMLFormElement" "\0"
  /*  5198 */ "HTMLFrameElement" "\0"
  /*  5215 */ "HTMLFrameSetElement" "\0"
  /*  5235 */ "HTMLHRElement" "\0"
  /*  5249 */ "HTMLHeadElement" "\0"
  /*  5265 */ "HTMLHeadingElement" "\0"
  /*  5284 */ "HTMLHtmlElement" "\0"
  /*  5300 */ "HTMLIFrameElement" "\0"
  /*  5318 */ "HTMLImageElement" "\0"
  /*  5335 */ "HTMLInputElement" "\0"
  /*  5352 */ "HTMLLIElement" "\0"
  /*  5366 */ "HTMLLabelElement" "\0"
  /*  5383 */ "HTMLLegendElement" "\0"
  /*  5401 */ "HTMLLinkElement" "\0"
  /*  5417 */ "HTMLMapElement" "\0"
  /*  5432 */ "HTMLMarqueeElement" "\0"
  /*  5451 */ "HTMLMediaElement" "\0"
  /*  5468 */ "HTMLMenuElement" "\0"
  /*  5484 */ "HTMLMetaElement" "\0"
  /*  5500 */ "HTMLMeterElement" "\0"
  /*  5517 */ "HTMLModElement" "\0"
  /*  5532 */ "HTMLOListElement" "\0"
  /*  5549 */ "HTMLObjectElement" "\0"
  /*  5567 */ "HTMLOptGroupElement" "\0"
  /*  5587 */ "HTMLOptionElement" "\0"
  /*  5605 */ "HTMLOptionsCollection" "\0"
  /*  5627 */ "HTMLOutputElement" "\0"
  /*  5645 */ "HTMLParagraphElement" "\0"
  /*  5666 */ "HTMLParamElement" "\0"
  /*  5683 */ "HTMLPictureElement" "\0"
  /*  5702 */ "HTMLPreElement" "\0"
  /*  5717 */ "HTMLProgressElement" "\0"
  /*  5737 */ "HTMLQuoteElement" "\0"
  /*  5754 */ "HTMLScriptElement" "\0"
  /*  5772 */ "HTMLSelectElement" "\0"
  /*  5790 */ "HTMLSlotElement" "\0"
  /*  5806 */ "HTMLSourceElement" "\0"
  /*  5824 */ "HTMLSpanElement" "\0"
  /*  5840 */ "HTMLStyleElement" "\0"
  /*  5857 */ "HTMLTableCaptionElement" "\0"
  /*  5881 */ "HTMLTableCellElement" "\0"
  /*  5902 */ "HTMLTableColElement" "\0"
  /*  5922 */ "HTMLTableElement" "\0"
  /*  5939 */ "HTMLTableRowElement" "\0"
  /*  5959 */ "HTMLTableSectionElement" "\0"
  /*  5983 */ "HTMLTemplateElement" "\0"
  /*  6003 */ "HTMLTextAreaElement" "\0"
  /*  6023 */ "HTMLTimeElement" "\0"
  /*  6039 */ "HTMLTitleElement" "\0"
  /*  6056 */ "HTMLTrackElement" "\0"
  /*  6073 */ "HTMLUListElement" "\0"
  /*  6090 */ "HTMLUnknownElement" "\0"
  /*  6109 */ "HTMLVideoElement" "\0"
  /*  6126 */ "HashChangeEvent" "\0"
  /*  6142 */ "Headers" "\0"
  /*  6150 */ "Headers Iterator" "\0"
  /*  6167 */ "HeapSnapshot" "\0"
  /*  6180 */ "History" "\0"
  /*  6188 */ "IDBCursor" "\0"
  /*  6198 */ "IDBCursorWithValue" "\0"
  /*  6217 */ "IDBDatabase" "\0"
  /*  6229 */ "IDBFactory" "\0"
  /*  6240 */ "IDBFileHandle" "\0"
  /*  6254 */ "IDBFileRequest" "\0"
  /*  6269 */ "IDBIndex" "\0"
  /*  6278 */ "IDBKeyRange" "\0"
  /*  6290 */ "IDBLocaleAwareKeyRange" "\0"
  /*  6313 */ "IDBMutableFile" "\0"
  /*  6328 */ "IDBObjectStore" "\0"
  /*  6343 */ "IDBOpenDBRequest" "\0"
  /*  6360 */ "IDBRequest" "\0"
  /*  6371 */ "IDBTransaction" "\0"
  /*  6386 */ "IDBVersionChangeEvent" "\0"
  /*  6408 */ "IIRFilterNode" "\0"
  /*  6422 */ "IOUtils" "\0"
  /*  6430 */ "IdentityCredential" "\0"
  /*  6449 */ "IdleDeadline" "\0"
  /*  6462 */ "Image" "\0"
  /*  6468 */ "ImageBitmap" "\0"
  /*  6480 */ "ImageBitmapRenderingContext" "\0"
  /*  6508 */ "ImageCapture" "\0"
  /*  6521 */ "ImageCaptureError" "\0"
  /*  6539 */ "ImageCaptureErrorEvent" "\0"
  /*  6562 */ "ImageData" "\0"
  /*  6572 */ "ImageDocument" "\0"
  /*  6586 */ "InputEvent" "\0"
  /*  6597 */ "InspectorFontFace" "\0"
  /*  6615 */ "InspectorUtils" "\0"
  /*  6630 */ "InstallTriggerImpl" "\0"
  /*  6649 */ "IntersectionObserver" "\0"
  /*  6670 */ "IntersectionObserverEntry" "\0"
  /*  6696 */ "IntlUtils" "\0"
  /*  6706 */ "JSProcessActorChild" "\0"
  /*  6726 */ "JSProcessActorParent" "\0"
  /*  6747 */ "JSWindowActorChild" "\0"
  /*  6766 */ "JSWindowActorParent" "\0"
  /*  6786 */ "KeyEvent" "\0"
  /*  6795 */ "KeyboardEvent" "\0"
  /*  6809 */ "KeyframeEffect" "\0"
  /*  6824 */ "L10nFileSource" "\0"
  /*  6839 */ "L10nOverlays" "\0"
  /*  6852 */ "L10nRegistry" "\0"
  /*  6865 */ "LegacyMozTCPSocket" "\0"
  /*  6884 */ "Localization" "\0"
  /*  6897 */ "Location" "\0"
  /*  6906 */ "Lock" "\0"
  /*  6911 */ "LockManager" "\0"
  /*  6923 */ "MIDIAccess" "\0"
  /*  6934 */ "MIDIConnectionEvent" "\0"
  /*  6954 */ "MIDIInput" "\0"
  /*  6964 */ "MIDIInputMap" "\0"
  /*  6977 */ "MIDIMessageEvent" "\0"
  /*  6994 */ "MIDIOutput" "\0"
  /*  7005 */ "MIDIOutputMap" "\0"
  /*  7019 */ "MIDIPort" "\0"
  /*  7028 */ "MOZ_debug" "\0"
  /*  7038 */ "MatchGlob" "\0"
  /*  7048 */ "MatchPattern" "\0"
  /*  7061 */ "MatchPatternSet" "\0"
  /*  7077 */ "MathMLElement" "\0"
  /*  7091 */ "MediaCapabilities" "\0"
  /*  7109 */ "MediaCapabilitiesInfo" "\0"
  /*  7131 */ "MediaControlService" "\0"
  /*  7151 */ "MediaController" "\0"
  /*  7167 */ "MediaDeviceInfo" "\0"
  /*  7183 */ "MediaDevices" "\0"
  /*  7196 */ "MediaElementAudioSourceNode" "\0"
  /*  7224 */ "MediaEncryptedEvent" "\0"
  /*  7244 */ "MediaError" "\0"
  /*  7255 */ "MediaKeyError" "\0"
  /*  7269 */ "MediaKeyMessageEvent" "\0"
  /*  7290 */ "MediaKeySession" "\0"
  /*  7306 */ "MediaKeyStatusMap" "\0"
  /*  7324 */ "MediaKeyStatusMap Iterator" "\0"
  /*  7351 */ "MediaKeySystemAccess" "\0"
  /*  7372 */ "MediaKeys" "\0"
  /*  7382 */ "MediaList" "\0"
  /*  7392 */ "MediaMetadata" "\0"
  /*  7406 */ "MediaQueryList" "\0"
  /*  7421 */ "MediaQueryListEvent" "\0"
  /*  7441 */ "MediaRecorder" "\0"
  /*  7455 */ "MediaRecorderErrorEvent" "\0"
  /*  7479 */ "MediaSession" "\0"
  /*  7492 */ "MediaSource" "\0"
  /*  7504 */ "MediaStream" "\0"
  /*  7516 */ "MediaStreamAudioDestinationNode" "\0"
  /*  7548 */ "MediaStreamAudioSourceNode" "\0"
  /*  7575 */ "MediaStreamError" "\0"
  /*  7592 */ "MediaStreamEvent" "\0"
  /*  7609 */ "MediaStreamTrack" "\0"
  /*  7626 */ "MediaStreamTrackAudioSourceNode" "\0"
  /*  7658 */ "MediaStreamTrackEvent" "\0"
  /*  7680 */ "MerchantValidationEvent" "\0"
  /*  7704 */ "MessageBroadcaster" "\0"
  /*  7723 */ "MessageChannel" "\0"
  /*  7738 */ "MessageEvent" "\0"
  /*  7751 */ "MessageListenerManager" "\0"
  /*  7774 */ "MessagePort" "\0"
  /*  7786 */ "MessageSender" "\0"
  /*  7800 */ "MimeType" "\0"
  /*  7809 */ "MimeTypeArray" "\0"
  /*  7823 */ "MouseEvent" "\0"
  /*  7834 */ "MouseScrollEvent" "\0"
  /*  7851 */ "MozCanvasPrintState" "\0"
  /*  7871 */ "MozDocumentMatcher" "\0"
  /*  7890 */ "MozDocumentObserver" "\0"
  /*  7910 */ "MozQueryInterface" "\0"
  /*  7928 */ "MozSharedMap" "\0"
  /*  7941 */ "MozSharedMap Iterator" "\0"
  /*  7963 */ "MozSharedMapChangeEvent" "\0"
  /*  7987 */ "MozStorageAsyncStatementParams" "\0"
  /*  8018 */ "MozStorageStatementParams" "\0"
  /*  8044 */ "MozStorageStatementRow" "\0"
  /*  8067 */ "MozWritableSharedMap" "\0"
  /*  8088 */ "MutationEvent" "\0"
  /*  8102 */ "MutationObserver" "\0"
  /*  8119 */ "MutationRecord" "\0"
  /*  8134 */ "NamedNodeMap" "\0"
  /*  8147 */ "NavigationPreloadManager" "\0"
  /*  8172 */ "Navigator" "\0"
  /*  8182 */ "NetworkInformation" "\0"
  /*  8201 */ "Node" "\0"
  /*  8206 */ "NodeFilter" "\0"
  /*  8217 */ "NodeIterator" "\0"
  /*  8230 */ "NodeList" "\0"
  /*  8239 */ "Notification" "\0"
  /*  8252 */ "NotificationEvent" "\0"
  /*  8270 */ "NotifyPaintEvent" "\0"
  /*  8287 */ "OES_draw_buffers_indexed" "\0"
  /*  8312 */ "OES_element_index_uint" "\0"
  /*  8335 */ "OES_fbo_render_mipmap" "\0"
  /*  8357 */ "OES_standard_derivatives" "\0"
  /*  8382 */ "OES_texture_float" "\0"
  /*  8400 */ "OES_texture_float_linear" "\0"
  /*  8425 */ "OES_texture_half_float" "\0"
  /*  8448 */ "OES_texture_half_float_linear" "\0"
  /*  8478 */ "OES_vertex_array_object" "\0"
  /*  8502 */ "OVR_multiview2" "\0"
  /*  8517 */ "OfflineAudioCompletionEvent" "\0"
  /*  8545 */ "OfflineAudioContext" "\0"
  /*  8565 */ "OfflineResourceList" "\0"
  /*  8585 */ "OffscreenCanvas" "\0"
  /*  8601 */ "OffscreenCanvasRenderingContext2D" "\0"
  /*  8635 */ "Option" "\0"
  /*  8642 */ "OscillatorNode" "\0"
  /*  8657 */ "PageTransitionEvent" "\0"
  /*  8677 */ "PaintRequest" "\0"
  /*  8690 */ "PaintRequestList" "\0"
  /*  8707 */ "PaintWorkletGlobalScope" "\0"
  /*  8731 */ "PannerNode" "\0"
  /*  8742 */ "ParentProcessMessageManager" "\0"
  /*  8770 */ "Path2D" "\0"
  /*  8777 */ "PathUtils" "\0"
  /*  8787 */ "PaymentAddress" "\0"
  /*  8802 */ "PaymentMethodChangeEvent" "\0"
  /*  8827 */ "PaymentRequest" "\0"
  /*  8842 */ "PaymentRequestUpdateEvent" "\0"
  /*  8868 */ "PaymentResponse" "\0"
  /*  8884 */ "Performance" "\0"
  /*  8896 */ "PerformanceEntry" "\0"
  /*  8913 */ "PerformanceEntryEvent" "\0"
  /*  8935 */ "PerformanceEventTiming" "\0"
  /*  8958 */ "PerformanceMark" "\0"
  /*  8974 */ "PerformanceMeasure" "\0"
  /*  8993 */ "PerformanceNavigation" "\0"
  /*  9015 */ "PerformanceNavigationTiming" "\0"
  /*  9043 */ "PerformanceObserver" "\0"
  /*  9063 */ "PerformanceObserverEntryList" "\0"
  /*  9092 */ "PerformancePaintTiming" "\0"
  /*  9115 */ "PerformanceResourceTiming" "\0"
  /*  9141 */ "PerformanceServerTiming" "\0"
  /*  9165 */ "PerformanceTiming" "\0"
  /*  9183 */ "PeriodicWave" "\0"
  /*  9196 */ "PermissionStatus" "\0"
  /*  9213 */ "Permissions" "\0"
  /*  9225 */ "PlacesBookmark" "\0"
  /*  9240 */ "PlacesBookmarkAddition" "\0"
  /*  9263 */ "PlacesBookmarkChanged" "\0"
  /*  9285 */ "PlacesBookmarkGuid" "\0"
  /*  9304 */ "PlacesBookmarkMoved" "\0"
  /*  9324 */ "PlacesBookmarkRemoved" "\0"
  /*  9346 */ "PlacesBookmarkTags" "\0"
  /*  9365 */ "PlacesBookmarkTime" "\0"
  /*  9384 */ "PlacesBookmarkTitle" "\0"
  /*  9404 */ "PlacesBookmarkUrl" "\0"
  /*  9422 */ "PlacesEvent" "\0"
  /*  9434 */ "PlacesFavicon" "\0"
  /*  9448 */ "PlacesHistoryCleared" "\0"
  /*  9469 */ "PlacesObservers" "\0"
  /*  9485 */ "PlacesPurgeCaches" "\0"
  /*  9503 */ "PlacesRanking" "\0"
  /*  9517 */ "PlacesVisit" "\0"
  /*  9529 */ "PlacesVisitRemoved" "\0"
  /*  9548 */ "PlacesVisitTitle" "\0"
  /*  9565 */ "PlacesWeakCallbackWrapper" "\0"
  /*  9591 */ "Plugin" "\0"
  /*  9598 */ "PluginArray" "\0"
  /*  9610 */ "PluginCrashedEvent" "\0"
  /*  9629 */ "PointerEvent" "\0"
  /*  9642 */ "PopStateEvent" "\0"
  /*  9656 */ "PopupBlockedEvent" "\0"
  /*  9674 */ "PopupPositionedEvent" "\0"
  /*  9695 */ "PositionStateEvent" "\0"
  /*  9714 */ "PrecompiledScript" "\0"
  /*  9732 */ "PrioEncoder" "\0"
  /*  9744 */ "ProcessMessageManager" "\0"
  /*  9766 */ "ProcessingInstruction" "\0"
  /*  9788 */ "ProgressEvent" "\0"
  /*  9802 */ "PromiseDebugging" "\0"
  /*  9819 */ "PromiseNativeHandler" "\0"
  /*  9840 */ "PromiseRejectionEvent" "\0"
  /*  9862 */ "PublicKeyCredential" "\0"
  /*  9882 */ "PushEvent" "\0"
  /*  9892 */ "PushManager" "\0"
  /*  9904 */ "PushManagerImpl" "\0"
  /*  9920 */ "PushMessageData" "\0"
  /*  9936 */ "PushSubscription" "\0"
  /*  9953 */ "PushSubscriptionOptions" "\0"
  /*  9977 */ "RadioNodeList" "\0"
  /*  9991 */ "Range" "\0"
  /*  9997 */ "ReadableByteStreamController" "\0"
  /* 10026 */ "ReadableStream" "\0"
  /* 10041 */ "ReadableStreamBYOBReader" "\0"
  /* 10066 */ "ReadableStreamBYOBRequest" "\0"
  /* 10092 */ "ReadableStreamDefaultController" "\0"
  /* 10124 */ "ReadableStreamDefaultReader" "\0"
  /* 10152 */ "Report" "\0"
  /* 10159 */ "ReportBody" "\0"
  /* 10170 */ "ReportingObserver" "\0"
  /* 10188 */ "Request" "\0"
  /* 10196 */ "ResizeObserver" "\0"
  /* 10211 */ "ResizeObserverEntry" "\0"
  /* 10231 */ "ResizeObserverSize" "\0"
  /* 10250 */ "Response" "\0"
  /* 10259 */ "SVGAElement" "\0"
  /* 10271 */ "SVGAngle" "\0"
  /* 10280 */ "SVGAnimateElement" "\0"
  /* 10298 */ "SVGAnimateMotionElement" "\0"
  /* 10322 */ "SVGAnimateTransformElement" "\0"
  /* 10349 */ "SVGAnimatedAngle" "\0"
  /* 10366 */ "SVGAnimatedBoolean" "\0"
  /* 10385 */ "SVGAnimatedEnumeration" "\0"
  /* 10408 */ "SVGAnimatedInteger" "\0"
  /* 10427 */ "SVGAnimatedLength" "\0"
  /* 10445 */ "SVGAnimatedLengthList" "\0"
  /* 10467 */ "SVGAnimatedNumber" "\0"
  /* 10485 */ "SVGAnimatedNumberList" "\0"
  /* 10507 */ "SVGAnimatedPreserveAspectRatio" "\0"
  /* 10538 */ "SVGAnimatedRect" "\0"
  /* 10554 */ "SVGAnimatedString" "\0"
  /* 10572 */ "SVGAnimatedTransformList" "\0"
  /* 10597 */ "SVGAnimationElement" "\0"
  /* 10617 */ "SVGCircleElement" "\0"
  /* 10634 */ "SVGClipPathElement" "\0"
  /* 10653 */ "SVGComponentTransferFunctionElement" "\0"
  /* 10689 */ "SVGDefsElement" "\0"
  /* 10704 */ "SVGDescElement" "\0"
  /* 10719 */ "SVGElement" "\0"
  /* 10730 */ "SVGEllipseElement" "\0"
  /* 10748 */ "SVGFEBlendElement" "\0"
  /* 10766 */ "SVGFEColorMatrixElement" "\0"
  /* 10790 */ "SVGFEComponentTransferElement" "\0"
  /* 10820 */ "SVGFECompositeElement" "\0"
  /* 10842 */ "SVGFEConvolveMatrixElement" "\0"
  /* 10869 */ "SVGFEDiffuseLightingElement" "\0"
  /* 10897 */ "SVGFEDisplacementMapElement" "\0"
  /* 10925 */ "SVGFEDistantLightElement" "\0"
  /* 10950 */ "SVGFEDropShadowElement" "\0"
  /* 10973 */ "SVGFEFloodElement" "\0"
  /* 10991 */ "SVGFEFuncAElement" "\0"
  /* 11009 */ "SVGFEFuncBElement" "\0"
  /* 11027 */ "SVGFEFuncGElement" "\0"
  /* 11045 */ "SVGFEFuncRElement" "\0"
  /* 11063 */ "SVGFEGaussianBlurElement" "\0"
  /* 11088 */ "SVGFEImageElement" "\0"
  /* 11106 */ "SVGFEMergeElement" "\0"
  /* 11124 */ "SVGFEMergeNodeElement" "\0"
  /* 11146 */ "SVGFEMorphologyElement" "\0"
  /* 11169 */ "SVGFEOffsetElement" "\0"
  /* 11188 */ "SVGFEPointLightElement" "\0"
  /* 11211 */ "SVGFESpecularLightingElement" "\0"
  /* 11240 */ "SVGFESpotLightElement" "\0"
  /* 11262 */ "SVGFETileElement" "\0"
  /* 11279 */ "SVGFETurbulenceElement" "\0"
  /* 11302 */ "SVGFilterElement" "\0"
  /* 11319 */ "SVGForeignObjectElement" "\0"
  /* 11343 */ "SVGGElement" "\0"
  /* 11355 */ "SVGGeometryElement" "\0"
  /* 11374 */ "SVGGradientElement" "\0"
  /* 11393 */ "SVGGraphicsElement" "\0"
  /* 11412 */ "SVGImageElement" "\0"
  /* 11428 */ "SVGLength" "\0"
  /* 11438 */ "SVGLengthList" "\0"
  /* 11452 */ "SVGLineElement" "\0"
  /* 11467 */ "SVGLinearGradientElement" "\0"
  /* 11492 */ "SVGMPathElement" "\0"
  /* 11508 */ "SVGMarkerElement" "\0"
  /* 11525 */ "SVGMaskElement" "\0"
  /* 11540 */ "SVGMatrix" "\0"
  /* 11550 */ "SVGMetadataElement" "\0"
  /* 11569 */ "SVGNumber" "\0"
  /* 11579 */ "SVGNumberList" "\0"
  /* 11593 */ "SVGPathElement" "\0"
  /* 11608 */ "SVGPathSeg" "\0"
  /* 11619 */ "SVGPathSegArcAbs" "\0"
  /* 11636 */ "SVGPathSegArcRel" "\0"
  /* 11653 */ "SVGPathSegClosePath" "\0"
  /* 11673 */ "SVGPathSegCurvetoCubicAbs" "\0"
  /* 11699 */ "SVGPathSegCurvetoCubicRel" "\0"
  /* 11725 */ "SVGPathSegCurvetoCubicSmoothAbs" "\0"
  /* 11757 */ "SVGPathSegCurvetoCubicSmoothRel" "\0"
  /* 11789 */ "SVGPathSegCurvetoQuadraticAbs" "\0"
  /* 11819 */ "SVGPathSegCurvetoQuadraticRel" "\0"
  /* 11849 */ "SVGPathSegCurvetoQuadraticSmoothAbs" "\0"
  /* 11885 */ "SVGPathSegCurvetoQuadraticSmoothRel" "\0"
  /* 11921 */ "SVGPathSegLinetoAbs" "\0"
  /* 11941 */ "SVGPathSegLinetoHorizontalAbs" "\0"
  /* 11971 */ "SVGPathSegLinetoHorizontalRel" "\0"
  /* 12001 */ "SVGPathSegLinetoRel" "\0"
  /* 12021 */ "SVGPathSegLinetoVerticalAbs" "\0"
  /* 12049 */ "SVGPathSegLinetoVerticalRel" "\0"
  /* 12077 */ "SVGPathSegList" "\0"
  /* 12092 */ "SVGPathSegMovetoAbs" "\0"
  /* 12112 */ "SVGPathSegMovetoRel" "\0"
  /* 12132 */ "SVGPatternElement" "\0"
  /* 12150 */ "SVGPoint" "\0"
  /* 12159 */ "SVGPointList" "\0"
  /* 12172 */ "SVGPolygonElement" "\0"
  /* 12190 */ "SVGPolylineElement" "\0"
  /* 12209 */ "SVGPreserveAspectRatio" "\0"
  /* 12232 */ "SVGRadialGradientElement" "\0"
  /* 12257 */ "SVGRect" "\0"
  /* 12265 */ "SVGRectElement" "\0"
  /* 12280 */ "SVGSVGElement" "\0"
  /* 12294 */ "SVGScriptElement" "\0"
  /* 12311 */ "SVGSetElement" "\0"
  /* 12325 */ "SVGStopElement" "\0"
  /* 12340 */ "SVGStringList" "\0"
  /* 12354 */ "SVGStyleElement" "\0"
  /* 12370 */ "SVGSwitchElement" "\0"
  /* 12387 */ "SVGSymbolElement" "\0"
  /* 12404 */ "SVGTSpanElement" "\0"
  /* 12420 */ "SVGTextContentElement" "\0"
  /* 12442 */ "SVGTextElement" "\0"
  /* 12457 */ "SVGTextPathElement" "\0"
  /* 12476 */ "SVGTextPositioningElement" "\0"
  /* 12502 */ "SVGTitleElement" "\0"
  /* 12518 */ "SVGTransform" "\0"
  /* 12531 */ "SVGTransformList" "\0"
  /* 12548 */ "SVGUnitTypes" "\0"
  /* 12561 */ "SVGUseElement" "\0"
  /* 12575 */ "SVGViewElement" "\0"
  /* 12590 */ "Sanitizer" "\0"
  /* 12600 */ "Scheduler" "\0"
  /* 12610 */ "Screen" "\0"
  /* 12617 */ "ScreenLuminance" "\0"
  /* 12633 */ "ScreenOrientation" "\0"
  /* 12651 */ "ScriptProcessorNode" "\0"
  /* 12671 */ "ScrollAreaEvent" "\0"
  /* 12687 */ "ScrollViewChangeEvent" "\0"
  /* 12709 */ "SecurityPolicyViolationEvent" "\0"
  /* 12738 */ "Selection" "\0"
  /* 12748 */ "ServiceWorker" "\0"
  /* 12762 */ "ServiceWorkerContainer" "\0"
  /* 12785 */ "ServiceWorkerGlobalScope" "\0"
  /* 12810 */ "ServiceWorkerRegistration" "\0"
  /* 12836 */ "SessionStoreFormData" "\0"
  /* 12857 */ "SessionStoreScrollData" "\0"
  /* 12880 */ "SessionStoreUtils" "\0"
  /* 12898 */ "ShadowRealmGlobalScope" "\0"
  /* 12921 */ "ShadowRoot" "\0"
  /* 12932 */ "SharedWorker" "\0"
  /* 12945 */ "SharedWorkerGlobalScope" "\0"
  /* 12969 */ "SimpleGestureEvent" "\0"
  /* 12988 */ "SourceBuffer" "\0"
  /* 13001 */ "SourceBufferList" "\0"
  /* 13018 */ "SpeechGrammar" "\0"
  /* 13032 */ "SpeechGrammarList" "\0"
  /* 13050 */ "SpeechRecognition" "\0"
  /* 13068 */ "SpeechRecognitionAlternative" "\0"
  /* 13097 */ "SpeechRecognitionError" "\0"
  /* 13120 */ "SpeechRecognitionEvent" "\0"
  /* 13143 */ "SpeechRecognitionResult" "\0"
  /* 13167 */ "SpeechRecognitionResultList" "\0"
  /* 13195 */ "SpeechSynthesis" "\0"
  /* 13211 */ "SpeechSynthesisErrorEvent" "\0"
  /* 13237 */ "SpeechSynthesisEvent" "\0"
  /* 13258 */ "SpeechSynthesisUtterance" "\0"
  /* 13283 */ "SpeechSynthesisVoice" "\0"
  /* 13304 */ "StaticRange" "\0"
  /* 13316 */ "StereoPannerNode" "\0"
  /* 13333 */ "Storage" "\0"
  /* 13341 */ "StorageEvent" "\0"
  /* 13354 */ "StorageManager" "\0"
  /* 13369 */ "StreamFilter" "\0"
  /* 13382 */ "StreamFilterDataEvent" "\0"
  /* 13404 */ "StructuredCloneHolder" "\0"
  /* 13426 */ "StructuredCloneTester" "\0"
  /* 13448 */ "StyleSheet" "\0"
  /* 13459 */ "StyleSheetApplicableStateChangeEvent" "\0"
  /* 13496 */ "StyleSheetList" "\0"
  /* 13511 */ "SubmitEvent" "\0"
  /* 13523 */ "SubtleCrypto" "\0"
  /* 13536 */ "SyncMessageSender" "\0"
  /* 13554 */ "SyncReadFile" "\0"
  /* 13567 */ "TCPServerSocket" "\0"
  /* 13583 */ "TCPServerSocketEvent" "\0"
  /* 13604 */ "TCPSocket" "\0"
  /* 13614 */ "TCPSocketErrorEvent" "\0"
  /* 13634 */ "TCPSocketEvent" "\0"
  /* 13649 */ "TaskController" "\0"
  /* 13664 */ "TaskPriorityChangeEvent" "\0"
  /* 13688 */ "TaskSignal" "\0"
  /* 13699 */ "TelemetryStopwatch" "\0"
  /* 13718 */ "TestUtils" "\0"
  /* 13728 */ "TestingDeprecatedInterface" "\0"
  /* 13755 */ "Text" "\0"
  /* 13760 */ "TextClause" "\0"
  /* 13771 */ "TextDecoder" "\0"
  /* 13783 */ "TextDecoderStream" "\0"
  /* 13801 */ "TextEncoder" "\0"
  /* 13813 */ "TextEncoderStream" "\0"
  /* 13831 */ "TextMetrics" "\0"
  /* 13843 */ "TextTrack" "\0"
  /* 13853 */ "TextTrackCue" "\0"
  /* 13866 */ "TextTrackCueList" "\0"
  /* 13883 */ "TextTrackList" "\0"
  /* 13897 */ "TimeEvent" "\0"
  /* 13907 */ "TimeRanges" "\0"
  /* 13918 */ "Touch" "\0"
  /* 13924 */ "TouchEvent" "\0"
  /* 13935 */ "TouchList" "\0"
  /* 13945 */ "TrackEvent" "\0"
  /* 13956 */ "TransformStream" "\0"
  /* 13972 */ "TransformStreamDefaultController" "\0"
  /* 14005 */ "TransitionEvent" "\0"
  /* 14021 */ "TreeColumn" "\0"
  /* 14032 */ "TreeColumns" "\0"
  /* 14044 */ "TreeContentView" "\0"
  /* 14060 */ "TreeWalker" "\0"
  /* 14071 */ "U2F" "\0"
  /* 14075 */ "UDPMessageEvent" "\0"
  /* 14091 */ "UDPSocket" "\0"
  /* 14101 */ "UIEvent" "\0"
  /* 14109 */ "URL" "\0"
  /* 14113 */ "URLSearchParams" "\0"
  /* 14129 */ "URLSearchParams Iterator" "\0"
  /* 14154 */ "UniFFIPointer" "\0"
  /* 14168 */ "UniFFIScaffolding" "\0"
  /* 14186 */ "UserInteraction" "\0"
  /* 14202 */ "UserProximityEvent" "\0"
  /* 14221 */ "VRDisplay" "\0"
  /* 14231 */ "VRDisplayCapabilities" "\0"
  /* 14253 */ "VRDisplayEvent" "\0"
  /* 14268 */ "VREyeParameters" "\0"
  /* 14284 */ "VRFieldOfView" "\0"
  /* 14298 */ "VRFrameData" "\0"
  /* 14310 */ "VRMockController" "\0"
  /* 14327 */ "VRMockDisplay" "\0"
  /* 14341 */ "VRPose" "\0"
  /* 14348 */ "VRServiceTest" "\0"
  /* 14362 */ "VRStageParameters" "\0"
  /* 14380 */ "VTTCue" "\0"
  /* 14387 */ "VTTRegion" "\0"
  /* 14397 */ "ValidityState" "\0"
  /* 14411 */ "VideoPlaybackQuality" "\0"
  /* 14432 */ "VideoTrack" "\0"
  /* 14443 */ "VideoTrackList" "\0"
  /* 14458 */ "VisualViewport" "\0"
  /* 14473 */ "WEBGL_color_buffer_float" "\0"
  /* 14498 */ "WEBGL_compressed_texture_astc" "\0"
  /* 14528 */ "WEBGL_compressed_texture_etc" "\0"
  /* 14557 */ "WEBGL_compressed_texture_etc1" "\0"
  /* 14587 */ "WEBGL_compressed_texture_pvrtc" "\0"
  /* 14618 */ "WEBGL_compressed_texture_s3tc" "\0"
  /* 14648 */ "WEBGL_compressed_texture_s3tc_srgb" "\0"
  /* 14683 */ "WEBGL_debug_renderer_info" "\0"
  /* 14709 */ "WEBGL_debug_shaders" "\0"
  /* 14729 */ "WEBGL_depth_texture" "\0"
  /* 14749 */ "WEBGL_draw_buffers" "\0"
  /* 14768 */ "WEBGL_explicit_present" "\0"
  /* 14791 */ "WEBGL_lose_context" "\0"
  /* 14810 */ "WaveShaperNode" "\0"
  /* 14825 */ "WebExtensionContentScript" "\0"
  /* 14851 */ "WebExtensionPolicy" "\0"
  /* 14870 */ "WebGL2RenderingContext" "\0"
  /* 14893 */ "WebGLActiveInfo" "\0"
  /* 14909 */ "WebGLBuffer" "\0"
  /* 14921 */ "WebGLContextEvent" "\0"
  /* 14939 */ "WebGLFramebuffer" "\0"
  /* 14956 */ "WebGLProgram" "\0"
  /* 14969 */ "WebGLQuery" "\0"
  /* 14980 */ "WebGLRenderbuffer" "\0"
  /* 14998 */ "WebGLRenderingContext" "\0"
  /* 15020 */ "WebGLSampler" "\0"
  /* 15033 */ "WebGLShader" "\0"
  /* 15045 */ "WebGLShaderPrecisionFormat" "\0"
  /* 15072 */ "WebGLSync" "\0"
  /* 15082 */ "WebGLTexture" "\0"
  /* 15095 */ "WebGLTransformFeedback" "\0"
  /* 15118 */ "WebGLUniformLocation" "\0"
  /* 15139 */ "WebGLVertexArrayObject" "\0"
  /* 15162 */ "WebKitCSSMatrix" "\0"
  /* 15178 */ "WebSocket" "\0"
  /* 15188 */ "WheelEvent" "\0"
  /* 15199 */ "Window" "\0"
  /* 15206 */ "WindowClient" "\0"
  /* 15219 */ "WindowContext" "\0"
  /* 15233 */ "WindowGlobalChild" "\0"
  /* 15251 */ "WindowGlobalParent" "\0"
  /* 15270 */ "WindowRoot" "\0"
  /* 15281 */ "Worker" "\0"
  /* 15288 */ "WorkerDebuggerGlobalScope" "\0"
  /* 15314 */ "WorkerGlobalScope" "\0"
  /* 15332 */ "WorkerLocation" "\0"
  /* 15347 */ "WorkerNavigator" "\0"
  /* 15363 */ "WorkerTestUtils" "\0"
  /* 15379 */ "Worklet" "\0"
  /* 15387 */ "WorkletGlobalScope" "\0"
  /* 15406 */ "WritableStream" "\0"
  /* 15421 */ "WritableStreamDefaultController" "\0"
  /* 15453 */ "WritableStreamDefaultWriter" "\0"
  /* 15481 */ "XMLDocument" "\0"
  /* 15493 */ "XMLHttpRequest" "\0"
  /* 15508 */ "XMLHttpRequestEventTarget" "\0"
  /* 15534 */ "XMLHttpRequestUpload" "\0"
  /* 15555 */ "XMLSerializer" "\0"
  /* 15569 */ "XPathEvaluator" "\0"
  /* 15584 */ "XPathExpression" "\0"
  /* 15600 */ "XPathResult" "\0"
  /* 15612 */ "XRBoundedReferenceSpace" "\0"
  /* 15636 */ "XRFrame" "\0"
  /* 15644 */ "XRInputSource" "\0"
  /* 15658 */ "XRInputSourceArray" "\0"
  /* 15677 */ "XRInputSourceEvent" "\0"
  /* 15696 */ "XRInputSourcesChangeEvent" "\0"
  /* 15722 */ "XRPose" "\0"
  /* 15729 */ "XRReferenceSpace" "\0"
  /* 15746 */ "XRReferenceSpaceEvent" "\0"
  /* 15768 */ "XRRenderState" "\0"
  /* 15782 */ "XRRigidTransform" "\0"
  /* 15799 */ "XRSession" "\0"
  /* 15809 */ "XRSessionEvent" "\0"
  /* 15824 */ "XRSpace" "\0"
  /* 15832 */ "XRSystem" "\0"
  /* 15841 */ "XRView" "\0"
  /* 15848 */ "XRViewerPose" "\0"
  /* 15861 */ "XRViewport" "\0"
  /* 15872 */ "XRWebGLLayer" "\0"
  /* 15885 */ "XSLTProcessor" "\0"
  /* 15899 */ "XULCommandEvent" "\0"
  /* 15915 */ "XULElement" "\0"
  /* 15926 */ "XULFrameElement" "\0"
  /* 15942 */ "XULMenuElement" "\0"
  /* 15957 */ "XULPopupElement" "\0"
  /* 15973 */ "XULResizerElement" "\0"
  /* 15991 */ "XULTextElement" "\0"
  /* 16006 */ "XULTreeElement" "\0"
  /* 16021 */ "console" "\0"
  /* 16029 */ "webkitSpeechGrammar" "\0"
  /* 16049 */ "webkitSpeechGrammarList" "\0"
  /* 16073 */ "webkitSpeechRecognition" "\0"
  /* 16097 */ "webkitURL"
};

}  // namespace binding_detail

// Making this enum bigger than a uint16_t has consequences on the size
// of some structs (eg. WebIDLNameTableEntry) and tables. We should try
// to avoid that.
static_assert(EnumTypeFitsWithin<BindingNamesOffset, uint16_t>::value,
              "Size increase");

} // namespace mozilla::dom

