//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PWebGPUTypes_h
#define PWebGPUTypes_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "nsTHashtable.h"
#include "mozilla/MozPromise.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/UniquePtr.h"
#include "mozilla/ipc/ByteBuf.h"
#include "mozilla/ipc/FileDescriptor.h"
#include "mozilla/ipc/ProtocolUtilsFwd.h"
#include "mozilla/ipc/Shmem.h"

// Headers for typedefs
#include "mozilla/ipc/IPCCore.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union MaybeShmem|
//
namespace mozilla {
namespace webgpu {
class MaybeShmem final
{
public:
    enum Type {
        T__None,
        TShmem = 1,
        Tnull_t,
        T__Last = Tnull_t
    };

private:
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::null_t null_t;
    typedef Shmem Shmem__tdef;
    typedef null_t null_t__tdef;

    union Value {
        mozilla::AlignedStorage2<Shmem> VShmem;
        mozilla::AlignedStorage2<null_t> Vnull_t;
    };

    Shmem*
    ptr_Shmem()
    {
        return ((mValue).VShmem).addr();
    }
    const Shmem*
    constptr_Shmem() const
    {
        return ((mValue).VShmem).addr();
    }
    null_t*
    ptr_null_t()
    {
        return ((mValue).Vnull_t).addr();
    }
    const null_t*
    constptr_null_t() const
    {
        return ((mValue).Vnull_t).addr();
    }

    void
    MaybeDestroy();

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT MaybeShmem() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT MaybeShmem(Shmem& aOther);

    MOZ_IMPLICIT MaybeShmem(Shmem&& aOther);

    MOZ_IMPLICIT MaybeShmem(const null_t& aOther);

    MOZ_IMPLICIT MaybeShmem(null_t&& aOther);

    MOZ_IMPLICIT MaybeShmem(const MaybeShmem& aOther);

    MOZ_IMPLICIT MaybeShmem(MaybeShmem&& aOther);

    ~MaybeShmem();

    Type
    type() const
    {
        return mType;
    }

    MaybeShmem&
    operator=(Shmem& aRhs);

    MaybeShmem&
    operator=(Shmem&& aRhs);

    MaybeShmem&
    operator=(const null_t& aRhs);

    MaybeShmem&
    operator=(null_t&& aRhs);

    MaybeShmem&
    operator=(const MaybeShmem& aRhs);

    MaybeShmem&
    operator=(MaybeShmem&& aRhs);

    bool
    operator==(Shmem& aRhs) const;

    bool
    operator==(const null_t& aRhs) const;

    bool
    operator==(const MaybeShmem& aRhs) const;

    Shmem&
    get_Shmem()
    {
        AssertSanity(TShmem);
        return (*(ptr_Shmem()));
    }
    Shmem&
    get_Shmem() const
    {
        AssertSanity(TShmem);
        return const_cast<Shmem&>((*(constptr_Shmem())));
    }
    operator Shmem&()
    {
        return get_Shmem();
    }
    operator Shmem&() const
    {
        return get_Shmem();
    }

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace webgpu
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::webgpu::MaybeShmem>
{
    typedef mozilla::webgpu::MaybeShmem paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct BufferMapSuccess|
//
namespace mozilla {
namespace webgpu {
class BufferMapSuccess final
{
private:

public:
    MOZ_IMPLICIT BufferMapSuccess() :
        writable_(),
        offset_(),
        size_()
    {
    }

    MOZ_IMPLICIT BufferMapSuccess(
            const uint64_t& _offset,
            const uint64_t& _size,
            const bool& _writable) :
        writable_(_writable),
        offset_(_offset),
        size_(_size)
    {
    }

    uint64_t&
    offset()
    {
        return offset_;
    }
    const uint64_t&
    offset() const
    {
        return offset_;
    }

    uint64_t&
    size()
    {
        return size_;
    }
    const uint64_t&
    size() const
    {
        return size_;
    }

    bool&
    writable()
    {
        return writable_;
    }
    const bool&
    writable() const
    {
        return writable_;
    }

private:
    void
    StaticAssertions() const;
    bool writable_;
    uint64_t offset_;
    uint64_t size_;
};
} // namespace webgpu
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::webgpu::BufferMapSuccess>
{
    typedef mozilla::webgpu::BufferMapSuccess paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct BufferMapError|
//
namespace mozilla {
namespace webgpu {
class BufferMapError final
{
private:

public:
    MOZ_IMPLICIT BufferMapError() :
        message_()
    {
    }

    MOZ_IMPLICIT BufferMapError(const nsCString& _message) :
        message_(_message)
    {
    }

    nsCString&
    message()
    {
        return message_;
    }
    const nsCString&
    message() const
    {
        return message_;
    }

private:
    nsCString message_;
};
} // namespace webgpu
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::webgpu::BufferMapError>
{
    typedef mozilla::webgpu::BufferMapError paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union BufferMapResult|
//
namespace mozilla {
namespace webgpu {
class BufferMapResult final
{
public:
    enum Type {
        T__None,
        TBufferMapSuccess = 1,
        TBufferMapError,
        T__Last = TBufferMapError
    };

private:
    typedef mozilla::webgpu::BufferMapSuccess BufferMapSuccess;
    typedef mozilla::webgpu::BufferMapError BufferMapError;
    typedef BufferMapSuccess BufferMapSuccess__tdef;
    typedef BufferMapError BufferMapError__tdef;

    union Value {
        mozilla::AlignedStorage2<BufferMapSuccess> VBufferMapSuccess;
        mozilla::AlignedStorage2<BufferMapError> VBufferMapError;
    };

    BufferMapSuccess*
    ptr_BufferMapSuccess()
    {
        return ((mValue).VBufferMapSuccess).addr();
    }
    const BufferMapSuccess*
    constptr_BufferMapSuccess() const
    {
        return ((mValue).VBufferMapSuccess).addr();
    }
    BufferMapError*
    ptr_BufferMapError()
    {
        return ((mValue).VBufferMapError).addr();
    }
    const BufferMapError*
    constptr_BufferMapError() const
    {
        return ((mValue).VBufferMapError).addr();
    }

    void
    MaybeDestroy();

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT BufferMapResult() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT BufferMapResult(const BufferMapSuccess& aOther);

    MOZ_IMPLICIT BufferMapResult(BufferMapSuccess&& aOther);

    MOZ_IMPLICIT BufferMapResult(const BufferMapError& aOther);

    MOZ_IMPLICIT BufferMapResult(BufferMapError&& aOther);

    MOZ_IMPLICIT BufferMapResult(const BufferMapResult& aOther);

    MOZ_IMPLICIT BufferMapResult(BufferMapResult&& aOther);

    ~BufferMapResult();

    Type
    type() const
    {
        return mType;
    }

    BufferMapResult&
    operator=(const BufferMapSuccess& aRhs);

    BufferMapResult&
    operator=(BufferMapSuccess&& aRhs);

    BufferMapResult&
    operator=(const BufferMapError& aRhs);

    BufferMapResult&
    operator=(BufferMapError&& aRhs);

    BufferMapResult&
    operator=(const BufferMapResult& aRhs);

    BufferMapResult&
    operator=(BufferMapResult&& aRhs);

    BufferMapSuccess&
    get_BufferMapSuccess()
    {
        AssertSanity(TBufferMapSuccess);
        return (*(ptr_BufferMapSuccess()));
    }
    const BufferMapSuccess&
    get_BufferMapSuccess() const
    {
        AssertSanity(TBufferMapSuccess);
        return (*(constptr_BufferMapSuccess()));
    }
    operator BufferMapSuccess&()
    {
        return get_BufferMapSuccess();
    }
    operator const BufferMapSuccess&() const
    {
        return get_BufferMapSuccess();
    }

    BufferMapError&
    get_BufferMapError()
    {
        AssertSanity(TBufferMapError);
        return (*(ptr_BufferMapError()));
    }
    const BufferMapError&
    get_BufferMapError() const
    {
        AssertSanity(TBufferMapError);
        return (*(constptr_BufferMapError()));
    }
    operator BufferMapError&()
    {
        return get_BufferMapError();
    }
    operator const BufferMapError&() const
    {
        return get_BufferMapError();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace webgpu
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::webgpu::BufferMapResult>
{
    typedef mozilla::webgpu::BufferMapResult paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC

#endif // ifndef PWebGPUTypes_h
